/*
 * dered.c
 * Dered  (DEcode Roboword Electric Dictionary) Ver. 1.0
 * Copyright (C) 2003 by Masashi Suzuto
 */

#include <stdio.h>
#include <stdlib.h>

const SizeHeader = 896;

int func(int var);

void main(int argc, char* argv[]) {
	FILE *fp_in, *fp_out;
	char index_head;
	int j, k, m, lz_length, lz_start, extend_num, index_vol;
	unsigned char buf[32768], text[32768];
	long BodyAddress, IndexAddress;

	if( argc < 3 ){
		perror("t@Cw肵ĂB\n");
		exit(1);
	}

	if( (fp_in = fopen(argv[1], "rb") ) == NULL ) {
		perror("Can't file open!\n");
		exit(1);
	}

	if( (fp_out = fopen(argv[2], "wb") ) == NULL ) {
		perror("Can't file open!\n");
		exit(1);
	}

	fseek( fp_in, SizeHeader, SEEK_SET );
	fread( &BodyAddress, 4, 1, fp_in );
	fseek( fp_in, 20L, SEEK_CUR );
	fread( &IndexAddress, 4, 1, fp_in );
	fseek( fp_in, BodyAddress, SEEK_SET );

	while ( ftell( fp_in ) < IndexAddress ) {
		extend_num = 0;
		fread( &index_head, 1, 1, fp_in );
		fread( &index_vol, 4, 1, fp_in );
		fseek( fp_in, 12L, SEEK_CUR );
		fread( &buf, index_vol, 1, fp_in );
		for ( j = 0; j < index_vol ; j++ ) {
			k = j + extend_num;
			switch ( buf[j] ) {
				case   0: text[k] = 0xBB; break;
				case   1: text[k] = 0x92; break;
				case   2: text[k] = 0x99; break;
				case   3: text[k] = 0x6A; break;
				case   4: text[k] = 0x94; break;
				case   5: text[k] = 0x97; break;
				case   6: text[k] = 0xBE; break;
				case   7: text[k] = 0x32; break;
				case   8: text[k] = 0xBA; break;
				case   9: text[k] = 0x85; break;
				case  10: text[k] = 0xB2; break;
				case  11: text[k] = 0x61; break;
				/* 12 0C */
				case  13: text[k] = 0xC8; break;
				case  14: text[k] = 0x5B; break;
				case  15: text[k] = 0xED; break;

				case  16: text[k] = 0x46; break;
				case  17: text[k] = 0xA8; break;
				case  18: text[k] = 0xA4; break;
				case  19: text[k] = 0x44; break;
				case  20: text[k] = 0x6D; break;
				case  21: text[k] = 0x3D; break;
				case  22: text[k] = 0xC6; break;
				case  23: text[k] = 0xD7; break;
				case  24: text[k] = 0xF1; break;
				case  25: text[k] = 0x48; break;
				case  26: text[k] = 0x4C; break;
				case  27: text[k] = 0xF6; break;
				case  28: text[k] = 0x50; break;
				case  29: text[k] = 0x80; break;
				case  30: text[k] = 0x8C; break;
				case  31: text[k] = 0x96; break;

				/* 32 20 */
				case  33: text[k] = 0x2F; break;
				case  34: text[k] = 0x8D; break;
				case  35: text[k] = text[k-2]; break;
				case  36: text[k] = 0x77; break;
				/* 37 25 */
				/* 38 26 */
				case  39: text[k] = 0x79; break;
				case  40: text[k] = 0xB5; break;
				/* 41 29 */
				case  41:
					lz_length = func( buf[j+1] );
					lz_start = func( buf[j+2] ) - 1;
					for ( m = 0; m < lz_length; m++) {
						text[k+m] = text[k-lz_start+m];
					}
					extend_num = extend_num + lz_length - 3;
					j = j + 2;
					break;
				case  42: text[k] = 0x67; break;
				case  43: text[k] = 0xB4; break;
				case  44: text[k] = 0xD3; break;
				case  45: text[k] = 0xC4; break;
				/* 46 2E */
				case  47: text[k] = 0x73; break;

				case  48: text[k] = 0xE5; break;
				case  49: text[k] = 0xF5; break;
				/* 50 32 */
				case  51: text[k] = 0x65; break;
				case  52: text[k] = 0xB1; break;
				case  53: text[k] = 0x39; break;
				case  54: text[k] = 0x91; break;
				case  55: text[k] = 0x37; break;
				case  56: text[k] = 0x30; break;
				/* 57 39 */
				case  58: text[k] = 0xE3; break;
				case  59: text[k] = 0x4A; break;
				case  60: text[k] = 0xA7; break;
				/* 61 3D 1 oCg̕ 3 o */
				case  61:
					text[k] = text[k-1];
					text[k+1] = text[k-1];
					text[k+2] = text[k-1];
					extend_num = extend_num + 2;
					break;
				case  62: text[k] = text[k-1]+3; break;
				case  63: text[k] = 0x5C; break;

				case  64: text[k] = 0x8B; break;
				case  65: text[k] = 0xC7; break;
				case  66: text[k] = text[k-1]-1; break;
				case  67: text[k] = 0x56; break;
				case  68: text[k] = 0xA2; break;
				case  69: text[k] = 0x5E; break;
				case  70: text[k] = 0x8E; break;
				case  71: text[k] = 0x90; break;
				case  72: text[k] = text[k-1]-3; break;
				case  73: text[k] = 0xE1; break;
				/* 74 4A 1 oCg̕ 2 o */
				case  74:
					text[k] = text[k-1];
					text[k+1] = text[k-1];
					extend_num = extend_num + 1;
					break;
				case  75: text[k] = 0x5F; break;
				case  76: text[k] = 0x6B; break;
				/* 77 4D */
				case  78: text[k] = 0x7E; break;
				case  79: text[k] = 0xC3; break;

				case  80: text[k] = 0x66; break;
				case  81: text[k] = 0x7D; break;
				case  82: text[k] = 0xA5; break;
				case  83: text[k] = 0xCD; break;
				case  84: text[k] = 0xE8; break;
				case  85: text[k] = 0xF7; break;
				case  86: text[k] = 0x70; break;
				case  87: text[k] = 0x75; break;
				case  88: text[k] = 0xE7; break;
				case  89: text[k] = 0x9E; break;
				case  90: text[k] = 0x65; break;
				case  91: text[k] = 0x3C; break;
				case  92: text[k] = 0x9D; break;
				case  93: text[k] = 0x20; break;
				case  94: text[k] = 0x6C; break;
				case  95: text[k] = 0xD3; break;

				case  96: text[k] = 0xCE; break;
				case  97: text[k] = 0xD9; break;
				case  98: text[k] = 0xD0; break;
				case  99: text[k] = 0xFB; break;
				case 100: text[k] = 0x24; break;
				case 101: text[k] = 0xBF; break;
				case 102: text[k] = 0x74; break;
				case 103: text[k] = 0xD1; break;
				case 104: text[k] = 0xE6; break;
				case 105: text[k] = 0xEE; break;
				case 106: text[k] = 0x60; break;
				case 107: text[k] = 0xCF; break;
				case 108: text[k] = 0xB6; break;
				case 109: text[k] = 0x28; break;
				case 110: text[k] = 0xF3; break;
				/*   111 6F */
				case 111:
					lz_length = func( buf[j+1] );
					lz_start = func( buf[j+2] ) - 2;
					for ( m = 0; m < lz_length; m++) {
						text[k+m] = text[k-lz_start+m];
					}
					extend_num = extend_num + lz_length - 3;
					j = j + 2;
					break;

				case 112: text[k] = 0xDA; break;
				case 113: text[k] = 0xDE; break;
				case 114: text[k] = 0xD8; break;
				case 115: text[k] = 0x51; break;
				case 116: text[k] = 0x40; break;
				case 117: text[k] = 0xD5; break;
				case 118: text[k] = 0x98; break;
				case 119: text[k] = 0x2E; break;
				/* 120 78 */
				case 120:
					lz_length = func( buf[j+1] );
					lz_start = func( buf[j+2] );
					for ( m = 0; m < lz_length; m++) {
						text[k+m] = text[k-lz_start+m];
					}
					extend_num = extend_num + lz_length - 3;
					j = j + 2;
					break;
				case 121: text[k] = 0xAB; break;
				case 122: text[k] = 0x5D; break;
				case 123: text[k] = 0x88; break;
				case 124: text[k] = 0x5A; break;
				case 125: text[k] = 0x4B; break;
				case 126: text[k] = 0xB7; break;
				case 127: text[k] = 0x36; break;

				case 128: text[k] = 0x63; break;
				case 129: text[k] = 0x45; break;
				case 130: text[k] = 0x9A; break;
				case 131: text[k] = 0x42; break;
				case 132: text[k] = 0xD4; break;
				case 133: text[k] = 0xAA; break;
				case 134: text[k] = 0xA2; break;
				case 135: text[k] = 0x53; break;
				case 136: text[k] = 0x2C; break;
				case 137: text[k] = 0x58; break;
				case 138: text[k] = 0x6F; break;
				case 139: text[k] = 0xC0; break;
				case 140: text[k] = 0xEB; break;
				case 141: text[k] = 0x4D; break;
				case 142: text[k] = 0x29; break;
				case 143: text[k] = 0xC2; break;

				case 144: text[k] = 0x76; break;
				case 145: text[k] = 0xAE; break;
				case 146: text[k] = 0x79; break;
				case 147: text[k] = 0xE0; break;
				case 148: text[k] = 0xFF; break;
				case 149: text[k] = 0x9F; break;
				case 150: text[k] = 0x3F; break;
				case 151: text[k] = 0x2D; break;
				case 152: text[k] = 0xA1; break;
				case 153: text[k] = 0x8A; break;
				case 154: text[k] = 0xF0; break;
				case 155: text[k] = 0xFC; break;
				case 156: text[k] = 0x81; break;
				case 157: text[k] = 0x4F; break;
				case 158: text[k] = 0xBC; break;
				case 159: text[k] = 0xC1; break;

				case 160: text[k] = 0x47; break;
				case 161: text[k] = 0x26; break;
				case 162: text[k] = 0xC1; break;
				case 163: text[k] = text[k-1]; break;
				case 164: text[k] = 0x62; break;
				case 165: text[k] = 0xB0; break;
				/* 166 A6 */
				case 167: text[k] = 0x43; break;
				case 168: text[k] = 0xC9; break;
				case 169: text[k] = 0xF4; break;
				case 170: text[k] = 0xEA; break;
				case 171: text[k] = 0x38; break;
				case 172: text[k] = 0xD6; break;
				case 173: text[k] = 0xA3; break;
				case 174: text[k] = 0x55; break;
				case 175: text[k] = 0xB9; break;

				case 176: text[k] = 0x69; break;
				/* 177 B1 */
				case 178: text[k] = 0x84; break;
				case 179: text[k] = 0xA9; break;
				case 180: text[k] = 0x52; break;
				case 181: text[k] = 0x54; break;
				case 182: text[k] = 0x87; break;
				case 183: text[k] = 0xE2; break;
				case 184: text[k] = 0x59; break;
				case 185: text[k] = 0xDD; break;
				case 186: text[k] = 0x9B; break;
				case 187: text[k] = 0x81; break;
				case 188: text[k] = 0x6E; break;
				case 189: text[k] = 0x33; break;
				case 190: text[k] = 0x34; break;
				case 191: text[k] = 0xDB; break;

				case 192: text[k] = 0x35; break;
				case 193: text[k] = 0xF9; break;
				case 194: text[k] = 0x7B; break;
				case 195: text[k] = 0xCA; break;
				case 196: text[k] = 0xCB; break;
				case 197: text[k] = 0xDC; break;
				case 198: text[k] = 0xA0; break;
				case 199: text[k] = 0x2B; break;
				case 200: text[k] = 0xB3; break;
				case 201: text[k] = 0xFE; break;
				case 202: text[k] = text[k-1]+2; break;
				/* 203 CB */
				case 204: text[k] = 0x72; break;
				case 205: text[k] = 0xC5; break;
				case 206: text[k] = 0xF8; break;
				case 207: text[k] = 0x9C; break;

				case 208: text[k] = 0x64; break;
				case 209: text[k] = 0x95; break;
				case 210: text[k] = 0x25; break;
				case 211: text[k] = 0xE4; break;
				case 212: text[k] = 0x89; break;
				case 213: text[k] = 0x82; break;
				case 214: text[k] = 0x7A; break;
				case 215: text[k] = 0xEF; break;
				case 216: text[k] = 0xBD; break;
				case 217: text[k] = 0x41; break;
				case 218: text[k] = 0x71; break;
				case 219: text[k] = 0xAF; break;
				case 220: text[k] = 0xAC; break;
				case 221: text[k] = 0x86; break;
				case 222: text[k] = text[k-1]+1; break;
				case 223: text[k] = 0x4E; break;

				/* 224 E0 */
				/* 225 E1 */
				case 226: text[k] = text[k-1]; break;
				case 227: text[k] = 0x68; break;
				case 228: text[k] = 0xE9; break;
				case 229: text[k] = 0x27; break;
				case 230: text[k] = 0x23; break;
				case 231: text[k] = 0xFA; break;
				case 232: text[k] = 0xEC; break;
				case 233: text[k] = text[k-1]-2; break;
				case 234: text[k] = 0x83; break;
				/* 235 EB */
				case 235:
					lz_length = func( buf[j+1] ) + 1;
					lz_start = func( buf[j+2] );
					for ( m = 0; m < lz_length; m++) {
						text[k+m] = text[k-lz_start+m];
					}
					extend_num = extend_num + lz_length - 3;
					j = j + 2;
					break;
				case 236: text[k] = 0xF2; break;
				case 237: /* 237 ED ꕶ폜*/
					if ( buf[j+1] == 202 ) { /* ED CAŉs */
						text[k] = 0x0A;
						j = j + 1;
					}
					extend_num = extend_num - 1;
					break;
				case 238: text[k] = 0xA6; break;
				case 239: text[k] = 0x3B; break;

				case 240: text[k] = 0x61; break;
				/* 241 F1 */
				case 242: text[k] = 0x49; break;
				case 243: text[k] = 0x7C; break;
				case 244: text[k] = 0xAD; break;
				case 245: text[k] = 0xD2; break;
				case 246: text[k] = 0x2A; break;
				case 247: text[k] = 0xB8; break;
				case 248: text[k] = 0xFD; break;
				case 249: text[k] = 0xDF; break;
				case 250: text[k] = 0x57; break;
				case 251: text[k] = 0x78; break;
				case 252: text[k] = 0x93; break;
				case 253: text[k] = 0xCC; break;
				case 254: text[k] = 0x31; break;
				case 255: text[k] = 0x8F; break;

				default: text[k] = buf[j];
			}
		}
		fwrite( text, index_vol + extend_num, 1, fp_out );
		fprintf( fp_out, "\n" );
	}
	fclose(fp_in);
	fclose(fp_out);
}

int func(int var) {
	switch ( var ) {
		case 241: return   3; break; /* F1 */
		case 237: return   4; break; /* ED */
		case 163: return   5; break; /* A3 */
		case  74: return   6; break; /* 4A */
		case  61: return   7; break; /* 3D */
		case  35: return   8; break; /* 23 */
		case  72: return   9; break; /* 48 */
		case 233: return  10; break; /* E9 */
		case  66: return  11; break; /* 42 */
		case 222: return  12; break; /* DE */
		case 202: return  13; break; /* CA */
		case  62: return  14; break; /* 3E */
		case 120: return  15; break; /* 78 */
		case  41: return  16; break; /* 29 */
		case 111: return  17; break; /* 6F */
		case 235: return  18; break; /* EB */
		case 177: return  19; break; /* B1 */
		case  90: return  20; break; /* 5A */
		case 240: return  21; break; /* F0 */
		case 146: return  22; break; /* 92 */
		case 156: return  23; break; /* 9C */
		case  68: return  24; break; /* 44 */
		case 162: return  25; break; /* A2 */
		case  44: return  26; break; /* 2C */
		case 226: return  27; break; /* E2 */
		case  37: return  28; break; /* 25 */
		case  57: return  29; break; /* 39 */
		case 203: return  30; break; /* CB */
		case  38: return  31; break; /* 26 */
		case  93: return  32; break; /* 5D */
		case  46: return  33; break; /* 2E */
		case  12: return  34; break; /* 0C */
		case 230: return  35; break; /* E6 */
		case 100: return  36; break; /* 64 */
		case 210: return  37; break; /* D2 */
		case 161: return  38; break; /* A1 */
		case 229: return  39; break; /* E5 */
		case 109: return  40; break; /* 6D */
		case 142: return  41; break; /* 8E */
		case 246: return  42; break; /* F6 */
		case 199: return  43; break; /* C7 */
		case 136: return  44; break; /* 88 */
		case 151: return  45; break; /* 97 */
		case 119: return  46; break; /* 77 */
		case  33: return  47; break; /* 21 */
		case  56: return  48; break; /* 38 */
		case 254: return  49; break; /* FE */
		case   7: return  50; break; /* 07 */
		case 189: return  51; break; /* BD */
		case 190: return  52; break; /* BE */
		case 192: return  53; break; /* C0 */
		case 127: return  54; break; /* 7F */
		case  55: return  55; break; /* 37 */
		case 171: return  56; break; /* AB */
		case  53: return  57; break; /* 35 */
		case  77: return  58; break; /* 4D */
		case 239: return  59; break; /* EF */
		case  91: return  60; break; /* 5B */
		case  21: return  61; break; /* 15 */
		case  32: return  62; break; /* 20 */
		case 150: return  63; break; /* 96 */
		case 116: return  64; break; /* 74 */
		case 217: return  65; break; /* D9 */
		case 131: return  66; break; /* 83 */
		case 167: return  67; break; /* A7 */
		case  19: return  68; break; /* 13 */
		case 129: return  69; break; /* 81 */
		case  16: return  70; break; /* 10 */
		case 160: return  71; break; /* A0 */
		case  25: return  72; break; /* 19 */
		case 242: return  73; break; /* F2 */
		case  59: return  74; break; /* 3B */
		case 125: return  75; break; /* 7D */
		case  26: return  76; break; /* 1A */
		case 141: return  77; break; /* 8D */
		case 223: return  78; break; /* DF */
		case 157: return  79; break; /* 9D */
		case  28: return  80; break; /* 1C */
		case 115: return  81; break; /* 73 */
		case 180: return  82; break; /* B4 */
		case 135: return  83; break; /* 87 */
		case 181: return  84; break; /* B5 */
		case 174: return  85; break; /* AE */
		case  67: return  86; break; /* 43 */
		case 250: return  87; break; /* FA */
		case 137: return  88; break; /* 89 */
		case 184: return  89; break; /* B8 */
		case 124: return  90; break; /* 7C */
		case  14: return  91; break; /* 0E */
		case  63: return  92; break; /* 3F */
		case 122: return  93; break; /* 7A */
		case  69: return  94; break; /* 45 */
		case  75: return  95; break; /* 4B */
		case 106: return  96; break; /* 6A */
		case  11: return  97; break; /* 0B */
		case 164: return  98; break; /* A4 */
		case 128: return  99; break; /* 80 */
		case 208: return 100; break; /* D0 */
		case  51: return 101; break; /* 33 */
		case  80: return 102; break; /* 50 */
		case  42: return 103; break; /* 2A */
		case 227: return 104; break; /* E3 */
		case 176: return 105; break; /* B0 */
		case   3: return 106; break; /* 03 */
		case  76: return 107; break; /* 4C */
		case  94: return 108; break; /* 5E */
		case  20: return 109; break; /* 14 */
		case 188: return 110; break; /* BC */
		case 138: return 111; break; /* 8A */
		case  86: return 112; break; /* 56 */
		case 218: return 113; break; /* DA */
		case 204: return 114; break; /* CC */
		case  47: return 115; break; /* 2F */
		case 102: return 116; break; /* 66 */
		case  87: return 117; break; /* 57 */
		case 144: return 118; break; /* 90 */
		case  36: return 119; break; /* 24 */
		case 251: return 120; break; /* FB */
		case  39: return 121; break; /* 27 */
		case 214: return 122; break; /* D6 */
		case 194: return 123; break; /* C2 */
		case 243: return 124; break; /* F3 */
		case  81: return 125; break; /* 51 */
		case  78: return 126; break; /* 4E */
		//               127
		case 166: return 127; break; /* A6 */
		case  29: return 128; break; /* 1D */
		case 187: return 129; break; /* BB */
		case 213: return 130; break; /* D5 */
		case 234: return 131; break; /* EA */
		case 178: return 132; break; /* B2 */
		case   9: return 133; break; /*  9 */
		case 221: return 134; break; /* DD */
		case 182: return 135; break; /* B6 */
		case 123: return 136; break; /* 7B */
		case 212: return 137; break; /* D4 */
		case 153: return 138; break; /* 99 */
		case  64: return 139; break; /* 40 */
		case  30: return 140; break; /* 1E */
		case  34: return 141; break; /* 22 */
		case  70: return 142; break; /* 46 */
		case 255: return 143; break; /* FF */
		case  71: return 144; break; /* 47 */
		case  54: return 145; break; /* 36 */
		case   1: return 146; break; /*  1 */
		case 252: return 147; break; /* FC */
		case   4: return 148; break; /*  4 */
		case 209: return 149; break; /* D1 */
		case  31: return 150; break; /* 1F */
		case   5: return 151; break; /*  5 */
		case 118: return 152; break; /* 76 */
		case   2: return 153; break; /*  2 */
		case 130: return 154; break; /* 82 */
		case 186: return 155; break; /* BA */
		case 207: return 156; break; /* CF */
		case  92: return 157; break; /* 5C */
		case  89: return 158; break; /* 59 */
		case 149: return 159; break; /* 95 */
		case 198: return 160; break; /* C6 */
		case 152: return 161; break; /* 98 */
		case 134: return 162; break; /* 86 */
		case 173: return 163; break; /* AD */
		case  18: return 164; break; /* 12 */
		case  82: return 165; break; /* 52 */
		case 238: return 166; break; /* EE */
		case  60: return 167; break; /* 3C */
		case  17: return 168; break; /* 11 */
		case 179: return 169; break; /* B3 */
		case 133: return 170; break; /* 85 */
		case 121: return 171; break; /* 79 */
		case 220: return 172; break; /* DC */
		case 244: return 173; break; /* F4 */
		case 145: return 174; break; /* 91 */
		case 219: return 175; break; /* DB */
		case 165: return 176; break; /* A5 */
		case  52: return 177; break; /* 34 */
		case  10: return 178; break; /* 0A */
		case 200: return 179; break; /* C8 */
		case  43: return 180; break; /* 2B */
		case  40: return 181; break; /* 28 */
		case 108: return 182; break; /* 6C */
		case 126: return 183; break; /* 7E */
		case 247: return 184; break; /* F7 */
		case 175: return 185; break; /* AF */
		case   8: return 186; break; /*  8 */
		case   0: return 187; break; /*  0 */
		case 158: return 188; break; /* 9E */
		case 216: return 189; break; /* D8 */
		case   6: return 190; break; /*  6 */
		case 101: return 191; break; /* 65 */
		case 139: return 192; break; /* 8B */
		case 159: return 193; break; /* 9F */
		case 143: return 194; break; /* 8F */
		case  79: return 195; break; /* 4F */
		case  45: return 196; break; /* 2D */
		case 205: return 197; break; /* CD */
		case  22: return 198; break; /* 16 */
		case  65: return 199; break; /* 41 */
		case  13: return 200; break; /* 0D */
		case 168: return 201; break; /* A8 */
		case 195: return 202; break; /* C3 */
		case 196: return 203; break; /* C4 */
		case 253: return 204; break; /* FD */
		case  83: return 205; break; /* 53 */
		case  96: return 206; break; /* 60 */
		case 107: return 207; break; /* 6B */
		case  98: return 208; break; /* 62 */
		case 103: return 209; break; /* 67 */
		case 245: return 210; break; /* F5 */
		case  95: return 211; break; /* 5F */
		case 132: return 212; break; /* 84 */
		case 117: return 213; break; /* 75 */
		case 172: return 214; break; /* AC */
		case  23: return 215; break; /* 17 */
		case 114: return 216; break; /* 72 */
		case  97: return 217; break; /* 61 */
		case 112: return 218; break; /* 70 */
		case 191: return 219; break; /* BF */
		case 197: return 220; break; /* C5 */
		case 185: return 221; break; /* B9 */
		case 113: return 222; break; /* 71 */
		case 249: return 223; break; /* F9 */
		case 147: return 224; break; /* 93 */
		case  73: return 225; break; /* 49 */
		case 183: return 226; break; /* B7 */
		case  58: return 227; break; /* 3A */
		case 211: return 228; break; /* D3 */
		case  48: return 229; break; /* 30 */
		case 104: return 230; break; /* 68 */
		case  88: return 231; break; /* 58 */
		case  84: return 232; break; /* 54 */
		case 228: return 233; break; /* E4 */
		case 170: return 234; break; /* AA */
		case 140: return 235; break; /* 8C */
		case 232: return 236; break; /* E8 */
		case  15: return 237; break; /* 0F */
		case 105: return 238; break; /* 69 */
		case 215: return 239; break; /* D7 */
		case 154: return 240; break; /* 9A */
		case  24: return 241; break; /* 18 */
		case 236: return 242; break; /* EC */
		case 110: return 243; break; /* 6E */
		case 169: return 244; break; /* A9 */
		case  49: return 245; break; /* 31 */
		case  27: return 246; break; /* 1B */
		case  85: return 247; break; /* 55 */
		case 206: return 248; break; /* CE */
		case 193: return 249; break; /* C1 */
		case 231: return 250; break; /* E7 */
		case  99: return 251; break; /* 63 */
		case 155: return 252; break; /* 9B */
		case 248: return 253; break; /* F8 */
		case 201: return 254; break; /* C9 */
		case 148: return 255; break; /* 94 */

		default: return 0;
	}
}
